package com.aidlab.aidlab_sdk

import androidx.annotation.NonNull

import io.flutter.embedding.engine.plugins.FlutterPlugin

class AidlabSdkPlugin: FlutterPlugin {

  private val aidlabSynchronizationHandler = AidlabSynchronizationHandler()
  private val aidlabHandler = AidlabHandler(aidlabSynchronizationHandler)
  private val aidlabSdkHandler = AidlabSdkHandler(aidlabHandler)

  override fun onAttachedToEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
    AidlabBluetoothManager.init(binding.applicationContext)
    AidlabBluetoothManager.lastConnectedAidlab?.disconnect()

    aidlabSynchronizationHandler.init(binding)
    aidlabSdkHandler.init(binding)
    aidlabHandler.init(binding)
  }

  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
    aidlabHandler.release()
    aidlabSdkHandler.release()
    aidlabSynchronizationHandler.release()
  }
}


