package com.aidlab.aidlab_sdk_example

import android.app.*
import android.content.Intent
import android.os.Build
import android.os.IBinder
import androidx.core.app.NotificationCompat
import io.flutter.Log
import io.flutter.embedding.engine.FlutterEngine
import io.flutter.embedding.engine.dart.DartExecutor
import io.flutter.view.FlutterCallbackInformation
import io.flutter.view.FlutterMain

class AppService : Service() {

    companion object {
        private const val NOTIFICATION_CHANNEL_ID = "CHANNEL_ID"
        private const val NOTIFICATION_ID = 1

        private var isRunning = false
        private var isActivityAlive = false
        var savedFlutterEngine: FlutterEngine? = null
            private set

        fun onFlutterEngineAttached(flutterEngine: FlutterEngine) {
            isActivityAlive = true
            savedFlutterEngine = flutterEngine
        }
        
        fun onActivityDestroy() {
            isActivityAlive = false
            if(!isRunning) {
                savedFlutterEngine?.destroy()
                savedFlutterEngine = null
            }
        }
    }

    override fun onStartCommand(intent: Intent?, flags: Int, startId: Int): Int {
        if(Build.VERSION.SDK_INT > Build.VERSION_CODES.O) {
            val channel = NotificationChannel(
                    NOTIFICATION_CHANNEL_ID,
                    "Aidlab service",
                    NotificationManager.IMPORTANCE_LOW
            )
            (getSystemService(NOTIFICATION_SERVICE) as NotificationManager)
                    .createNotificationChannel(channel)


        }

        val notification: Notification = NotificationCompat.Builder(this, NOTIFICATION_CHANNEL_ID)
                .setContentTitle("Aidlab flutter example")
                .setContentText("Aidlab example app running in the background")
//                .setSmallIcon(R.drawable.ic_stat_hot_tub)
                .build()

        startForeground(NOTIFICATION_ID, notification)

        return START_STICKY
    }

    override fun onCreate() {
        super.onCreate()
        isRunning = true
    }

    override fun onDestroy() {
        super.onDestroy()
        isRunning = false

        if(!isActivityAlive) {
            savedFlutterEngine?.destroy()
        }
    }

    override fun onBind(intent: Intent?): IBinder? {
        return null
    }


}