package com.aidlab.aidlab_sdk_example

import android.app.Activity
import android.app.Application
import android.os.Bundle

object FlutterLifecycleDetector {
    private val callbacks: Application.ActivityLifecycleCallbacks =
            LifecycleCallbacks()

    var listener: Listener? = null

    var isActivityRunning = false
        private set

    fun init(app: Application) {
        app.registerActivityLifecycleCallbacks(callbacks)
    }

    interface Listener {
        fun onFlutterActivityCreated()
        fun onFlutterActivityDestroyed()
    }

    private class LifecycleCallbacks :
            Application.ActivityLifecycleCallbacks {
        override fun onActivityCreated(
                activity: Activity, state: Bundle?) {
            if (activity is MainActivity) {
                isActivityRunning = true
                listener?.onFlutterActivityCreated()
            }
        }

        override fun onActivityDestroyed(activity: Activity) {
            if (activity is MainActivity) {
                isActivityRunning = false
                listener?.onFlutterActivityDestroyed()
            }
        }

        override fun onActivityStarted(activity: Activity) { }

        override fun onActivityResumed(activity: Activity) { }

        override fun onActivityPaused(activity: Activity) { }

        override fun onActivityStopped(activity: Activity) { }

        override fun onActivitySaveInstanceState(activity: Activity, outState: Bundle) { }
    }
}