package com.aidlab.aidlab_sdk_example

import android.content.Context
import android.content.Intent
import io.flutter.embedding.android.FlutterActivity
import io.flutter.embedding.engine.FlutterEngine
import io.flutter.plugin.common.MethodChannel


class MainActivity: FlutterActivity() {

    private val SERVICE_CHANNEL = "com.aidlab.flutter_sdk_example/service"
    
    private var startServiceResult: MethodChannel.Result? = null

    override fun provideFlutterEngine(context: Context): FlutterEngine? {
        return AppService.savedFlutterEngine
    }

    override fun shouldDestroyEngineWithHost(): Boolean {
        return false
    }

    override fun configureFlutterEngine(flutterEngine: FlutterEngine) {
        super.configureFlutterEngine(flutterEngine)
        AppService.onFlutterEngineAttached(flutterEngine)
        MethodChannel(flutterEngine.dartExecutor.binaryMessenger, SERVICE_CHANNEL).
        setMethodCallHandler { call, result ->
            when(call.method) {
                "startService" -> {
                    startService(Intent(this, AppService::class.java))
                    startServiceResult = result
                }
                "stopService" -> {
                    stopService(Intent(this, AppService::class.java))
                }
            }
        }
    }

    override fun onDestroy() {
        super.onDestroy()
        AppService.onActivityDestroy()
    }

    override fun onFlutterUiNoLongerDisplayed() {
        super.onFlutterUiNoLongerDisplayed()
    }
}
