// Autogenerated from Pigeon (v0.1.17), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import <Foundation/Foundation.h>
@protocol FlutterBinaryMessenger;
@class FlutterError;
@class FlutterStandardTypedData;

NS_ASSUME_NONNULL_BEGIN

@class EmptyEvent;
@class ScanFailedEvent;
@class AidlabDetectedEvent;
@class ConnectRequest;
@class SyncStateEvent;
@class EcgEvent;
@class RespirationEvent;
@class SkinTemperatureEvent;
@class HeartRateEvent;
@class UnsynchronizedSizeEvent;
@class RespirationRateEvent;
@class ActivityEvent;
@class StepsEvent;
@class SendRequest;
@class EcgFiltrationRequest;
@class FirmwareInfoRequest;
@class FirmwareUpdateRequest;
@class FirmwareInformationEvent;
@class PressureEvent;
@class PressureWearStateEvent;
@class UpdateProgress;
@class ConnectEvent;
@class BatteryLevelEvent;
@class VectorEvent;
@class QuaternionEvent;
@class OrientationEvent;
@class WearStateEvent;
@class ExerciseEvent;
@class SoundVolumeEvent;
@class ErrorEvent;
@class MessageEvent;

@interface EmptyEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * nothing;
@end

@interface ScanFailedEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * errorCode;
@end

@interface AidlabDetectedEvent : NSObject
@property(nonatomic, copy, nullable) NSString * address;
@property(nonatomic, strong, nullable) NSNumber * rssi;
@end

@interface ConnectRequest : NSObject
@property(nonatomic, copy, nullable) NSString * address;
@property(nonatomic, strong, nullable) FlutterStandardTypedData * signals;
@end

@interface SyncStateEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * state;
@end

@interface EcgEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * timestamp;
@property(nonatomic, strong, nullable) FlutterStandardTypedData * values;
@end

@interface RespirationEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * timestamp;
@property(nonatomic, strong, nullable) FlutterStandardTypedData * values;
@end

@interface SkinTemperatureEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * timestamp;
@property(nonatomic, strong, nullable) NSNumber * value;
@end

@interface HeartRateEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * timestamp;
@property(nonatomic, strong, nullable) NSNumber * heartRate;
@property(nonatomic, strong, nullable) FlutterStandardTypedData * hrv;
@end

@interface UnsynchronizedSizeEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * unsynchronizedSize;
@end

@interface RespirationRateEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * timestamp;
@property(nonatomic, strong, nullable) NSNumber * value;
@end

@interface ActivityEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * timestamp;
@property(nonatomic, strong, nullable) NSNumber * activityType;
@end

@interface StepsEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * timestamp;
@property(nonatomic, strong, nullable) NSNumber * value;
@end

@interface SendRequest : NSObject
@property(nonatomic, copy, nullable) NSString * command;
@end

@interface EcgFiltrationRequest : NSObject
@property(nonatomic, strong, nullable) NSNumber * method;
@end

@interface FirmwareInfoRequest : NSObject
@property(nonatomic, copy, nullable) NSString * url;
@end

@interface FirmwareUpdateRequest : NSObject
@property(nonatomic, copy, nullable) NSString * url;
@property(nonatomic, copy, nullable) NSString * updatableVersion;
@end

@interface FirmwareInformationEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * updateAvailable;
@property(nonatomic, copy, nullable) NSString * updatableVersion;
@end

@interface PressureEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * timestamp;
@property(nonatomic, strong, nullable) FlutterStandardTypedData * values;
@end

@interface PressureWearStateEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * wearState;
@end

@interface UpdateProgress : NSObject
@property(nonatomic, strong, nullable) NSNumber * progress;
@end

@interface ConnectEvent : NSObject
@property(nonatomic, copy, nullable) NSString * firmwareRevision;
@property(nonatomic, copy, nullable) NSString * hardwareRevision;
@property(nonatomic, copy, nullable) NSString * serialNumber;
@end

@interface BatteryLevelEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * stateOfCharge;
@end

@interface VectorEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * timestamp;
@property(nonatomic, strong, nullable) NSNumber * x;
@property(nonatomic, strong, nullable) NSNumber * y;
@property(nonatomic, strong, nullable) NSNumber * z;
@end

@interface QuaternionEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * timestamp;
@property(nonatomic, strong, nullable) NSNumber * qw;
@property(nonatomic, strong, nullable) NSNumber * qx;
@property(nonatomic, strong, nullable) NSNumber * qy;
@property(nonatomic, strong, nullable) NSNumber * qz;
@end

@interface OrientationEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * timestamp;
@property(nonatomic, strong, nullable) NSNumber * roll;
@property(nonatomic, strong, nullable) NSNumber * pitch;
@property(nonatomic, strong, nullable) NSNumber * yaw;
@property(nonatomic, strong, nullable) NSNumber * bodyPosition;
@end

@interface WearStateEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * wearState;
@end

@interface ExerciseEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * exercise;
@end

@interface SoundVolumeEvent : NSObject
@property(nonatomic, strong, nullable) NSNumber * timestamp;
@property(nonatomic, strong, nullable) NSNumber * soundVolume;
@end

@interface ErrorEvent : NSObject
@property(nonatomic, copy, nullable) NSString * error;
@end

@interface MessageEvent : NSObject
@property(nonatomic, copy, nullable) NSString * process;
@property(nonatomic, copy, nullable) NSString * message;
@end

@interface PlatformAidlabSdkDelegate : NSObject
- (instancetype)initWithBinaryMessenger:(id<FlutterBinaryMessenger>)binaryMessenger;
- (void)onBluetoothStarted:(EmptyEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)onDeviceScanStarted:(EmptyEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)onDeviceScanStopped:(EmptyEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)onScanFailed:(ScanFailedEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)onAidlabDetected:(AidlabDetectedEvent*)input completion:(void(^)(NSError* _Nullable))completion;
@end
@protocol PlatformAidlabSdk
-(void)scanForDevices:(FlutterError *_Nullable *_Nonnull)error;
-(void)stopDeviceScan:(FlutterError *_Nullable *_Nonnull)error;
-(void)connect:(ConnectRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void PlatformAidlabSdkSetup(id<FlutterBinaryMessenger> binaryMessenger, id<PlatformAidlabSdk> _Nullable api);

@interface PlatformAidlabSynchronizationDelegate : NSObject
- (instancetype)initWithBinaryMessenger:(id<FlutterBinaryMessenger>)binaryMessenger;
- (void)syncStateDidChange:(SyncStateEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceivePastECG:(EcgEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceivePastRespiration:(RespirationEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceivePastSkinTemperature:(SkinTemperatureEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceivePastHeartRate:(HeartRateEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveUnsynchronizedSize:(UnsynchronizedSizeEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceivePastRespirationRate:(RespirationRateEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceivePastActivity:(ActivityEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceivePastSteps:(StepsEvent*)input completion:(void(^)(NSError* _Nullable))completion;
@end
@protocol PlatformAidlab
-(void)disconnect:(FlutterError *_Nullable *_Nonnull)error;
-(void)send:(SendRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
-(void)setECGFiltrationMethod:(EcgFiltrationRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
-(void)startSynchronization:(FlutterError *_Nullable *_Nonnull)error;
-(void)stopSynchronization:(FlutterError *_Nullable *_Nonnull)error;
-(void)requestForFirmwareInfo:(FirmwareInfoRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
-(void)startFirmwareUpdate:(FirmwareUpdateRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void PlatformAidlabSetup(id<FlutterBinaryMessenger> binaryMessenger, id<PlatformAidlab> _Nullable api);

@interface PlatformAidlabInternalDelegate : NSObject
- (instancetype)initWithBinaryMessenger:(id<FlutterBinaryMessenger>)binaryMessenger;
- (void)didReceiveFirmwareInformation:(FirmwareInformationEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceivePressure:(PressureEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)pressureWearStateDidChange:(PressureWearStateEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveUserEvent:(EmptyEvent*)input completion:(void(^)(NSError* _Nullable))completion;
@end
@interface PlatformAidlabUpdateDelegate : NSObject
- (instancetype)initWithBinaryMessenger:(id<FlutterBinaryMessenger>)binaryMessenger;
- (void)didFinishUpdate:(EmptyEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveUpdateError:(EmptyEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveUpdateProgress:(UpdateProgress*)input completion:(void(^)(NSError* _Nullable))completion;
@end
@interface PlatformAidlabDelegate : NSObject
- (instancetype)initWithBinaryMessenger:(id<FlutterBinaryMessenger>)binaryMessenger;
- (void)didConnect:(ConnectEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didDisconnect:(EmptyEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveEcg:(EcgEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveRespiration:(RespirationEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveRespirationRate:(RespirationRateEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveBatteryLevel:(BatteryLevelEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveSkinTemperature:(SkinTemperatureEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveAccelerometer:(VectorEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveGyroscope:(VectorEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveMagnetometer:(VectorEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveQuaternion:(QuaternionEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveOrientation:(OrientationEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveActivity:(ActivityEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveSteps:(StepsEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveHeartRate:(HeartRateEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)wearStateDidChange:(WearStateEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didDetectExercise:(ExerciseEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveSoundVolume:(SoundVolumeEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveCommand:(EmptyEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveError:(ErrorEvent*)input completion:(void(^)(NSError* _Nullable))completion;
- (void)didReceiveMessage:(MessageEvent*)input completion:(void(^)(NSError* _Nullable))completion;
@end
NS_ASSUME_NONNULL_END
