

enum ActivityType {
  Automotive,
  Walking,
  Running,
  Cycling,
  Still
}

extension ActivityTypeExtension on ActivityType {

  int get value {
    switch (this) {
      case ActivityType.Automotive:
        return 1;
      case ActivityType.Walking:
        return 2;
      case ActivityType.Running:
        return 4;
      case ActivityType.Cycling:
        return 8;
      case ActivityType.Still:
        return 16;
    }
    throw ArgumentError("Failed to parse to value $this");
  }

  static ActivityType fromValue(int value) {
    return ActivityType.values.firstWhere(
            (element) => element.value == value,
            orElse: () => throw ArgumentError("Failed to parse ActivityType from value: value: $value")
    );
  }
}