
import 'dart:developer';
import 'dart:typed_data';

import '../wrappers/aidlab_sdk_wrapper.dart';
import '../wrappers/aidlab_delegate_wrapper.dart';

import '../wrappers/platform_aidlab_sdk.dart';
import 'aidlab_delegate.dart';
import 'aidlab_sdk_delegate.dart';
import 'signal.dart';


class AidlabSdk {
  AidlabSdk._inner();

  static AidlabSdk instance = AidlabSdk._inner();

  final PlatformAidlabSdk _platformSdk = PlatformAidlabSdk();

  set aidlabSdkDelegate(AidlabSdkDelegate aidlabSdkDelegate) {
    AidlabSdkDelegateWrapper.listen(aidlabSdkDelegate);
  }

  void connect(String address, List<Signal> signals, AidlabDelegate aidlabDelegate) {
    log("Connecting");
    AidlabDelegateWrapper.listen(aidlabDelegate);
    _platformSdk.connect(
      ConnectRequest()
        ..address = address
        ..signals = Int32List.fromList(signals.map((e) => e.value).toList())
    );
  }

  void scanForDevices() {
    _platformSdk.scanForDevices();
  }

  void stopDeviceScan() {
    _platformSdk.stopDeviceScan();
  }
}
