

import 'dart:developer';

import 'package:aidlab_sdk/aidlab_sdk.dart';
import 'package:aidlab_sdk/src/wrappers/platform_aidlab_sdk.dart';

class AidlabSynchronizationWrapper implements PlatformAidlabSynchronizationDelegate {

  final Aidlab aidlab;
  AidlabSynchronizationDelegate delegate;

  AidlabSynchronizationWrapper(this.aidlab) {
    PlatformAidlabSynchronizationDelegate.setup(this);
  }

  static void release() {
    PlatformAidlabSynchronizationDelegate.setup(null);
  }

  @override
  void didReceivePastActivity(ActivityEvent arg) {
    delegate?.didReceivePastActivity(aidlab, arg.timestamp, ActivityTypeExtension.fromValue(arg.activityType));
  }

  @override
  void didReceivePastECG(EcgEvent arg) {
    delegate?.didReceivePastECG(aidlab, arg.timestamp, arg.values.toList());
  }

  @override
  void didReceivePastHeartRate(HeartRateEvent arg) {
    delegate?.didReceivePastHeartRate(aidlab, arg.timestamp, arg.hrv.toList(), arg.heartRate);
  }

  @override
  void didReceivePastRespiration(RespirationEvent arg) {
    delegate?.didReceivePastRespiration(aidlab, arg.timestamp, arg.values.toList());
  }

  @override
  void didReceivePastRespirationRate(RespirationRateEvent arg) {
    delegate?.didReceivePastRespirationRate(aidlab, arg.timestamp, arg.value);
  }

  @override
  void didReceivePastSkinTemperature(SkinTemperatureEvent arg) {
    delegate?.didReceivePastSkinTemperature(aidlab, arg.timestamp, arg.value);
  }

  @override
  void didReceivePastSteps(StepsEvent arg) {
    delegate?.didReceivePastSteps(aidlab, arg.timestamp, arg.value);
  }

  @override
  void didReceiveUnsynchronizedSize(UnsynchronizedSizeEvent arg) {
    delegate?.didReceiveUnsynchronizedSize(aidlab, arg.unsynchronizedSize);
  }

  @override
  void syncStateDidChange(SyncStateEvent arg) {
    log("syncStateDidChange - ${arg.state}");
    delegate?.syncStateDidChange(aidlab, SyncStateExtension.fromValue(arg.state));
  }

}