import 'package:aidlab_sdk/src/api/internal/internal_aidlab_update_delegate.dart';

import '../../aidlab_sdk.dart';
import '../wrappers/platform_aidlab_sdk.dart';

class AidlabUpdateDelegateWrapper implements PlatformAidlabUpdateDelegate {

  final Aidlab aidlab;
  InternalAidlabUpdateDelegate delegate;

  AidlabUpdateDelegateWrapper(this.aidlab) {
    PlatformAidlabUpdateDelegate.setup(this);
  }

  static void release() {
    PlatformAidlabUpdateDelegate.setup(null);
  }

  @override
  void didFinishUpdate(EmptyEvent arg) {
    delegate?.didFinishUpdate();
  }


  @override
  void didReceiveUpdateError(EmptyEvent arg) {
    delegate?.didReceiveUpdateError();
  }

  @override
  void didReceiveUpdateProgress(UpdateProgress arg) {
    delegate?.didReceiveUpdateProgress(arg.progress);
  }
}