import 'package:pigeon/pigeon.dart';

import 'aidlab_delegate.dart';


@HostApi()
abstract class PlatformAidlab {
  void disconnect();

  void send(SendRequest sendRequest);

  void setECGFiltrationMethod(EcgFiltrationRequest ecgFiltrationRequest);

  void startSynchronization();

  void stopSynchronization();

  void requestForFirmwareInfo(FirmwareInfoRequest firmwareInfoRequest);

  void startFirmwareUpdate(FirmwareUpdateRequest firmwareUpdateRequest);
}

class SendRequest {
  String command;
}

class EcgFiltrationRequest {
  int method;
}

class FirmwareInfoRequest {
  String url;
}

class FirmwareUpdateRequest {
  String url;
  String updatableVersion;
}

@FlutterApi()
abstract class PlatformAidlabSynchronizationDelegate {
  void syncStateDidChange(SyncStateEvent syncStateEvent);

  void didReceivePastECG(EcgEvent ecgEvent);

  void didReceivePastRespiration(RespirationEvent respirationEvent);

  void didReceivePastSkinTemperature(SkinTemperatureEvent skinTemperatureEvent);

  void didReceivePastHeartRate(HeartRateEvent heartRateEvent);

  void didReceiveUnsynchronizedSize(
      UnsynchronizedSizeEvent unsynchronizedSizeEvent);

  void didReceivePastRespirationRate(RespirationRateEvent respirationRateEvent);

  void didReceivePastActivity(ActivityEvent activityEvent);

  void didReceivePastSteps(StepsEvent stepsEvent);
}

class SyncStateEvent {
  int state;
}

class UnsynchronizedSizeEvent {
  int unsynchronizedSize;
}
