import 'package:pigeon/pigeon.dart';

import 'empty_event.dart';

@FlutterApi()
abstract class PlatformAidlabInternalDelegate {
  void didReceiveFirmwareInformation(
      FirmwareInformationEvent firmwareInformationEvent);

  void didReceivePressure(PressureEvent pressureEvent);

  void pressureWearStateDidChange(PressureWearStateEvent wearStateEvent);

  void didReceiveUserEvent(EmptyEvent emptyEvent);

}

@FlutterApi()
abstract class PlatformAidlabUpdateDelegate {
  void didFinishUpdate(EmptyEvent nothing);

  //TODO: error info
  void didReceiveUpdateError(EmptyEvent nothing);

  void didReceiveUpdateProgress(UpdateProgress progress);
}

class FirmwareInformationEvent {
  bool updateAvailable;
  String updatableVersion;
}

class PressureEvent {
  int timestamp;
  Int32List values;
}

class PressureWearStateEvent {
  int wearState;
}

class UpdateProgress {
  int progress;
}
