import 'package:pigeon/pigeon.dart';

import 'aidlab.dart';
import 'aidlab_internal.dart';
import 'empty_event.dart';

void configurePigeon(PigeonOptions options) {
  options.dartOut = "lib/src/wrappers/platform_aidlab_sdk.dart";

  options.objcHeaderOut = "ios/Classes/AidlabFlutter.h";
  options.objcSourceOut = "ios/Classes/AidlabFlutter.m";

  options.javaOut =
      "android/src/main/kotlin/com/aidlab/aidlab_sdk/AidlabFlutter.java";
  options.javaOptions.package = "com.aidlab.aidlab_sdk";
}

class ConnectRequest {
  String address;
  Int32List signals;
}

class AidlabDetectedEvent {
  String address;
  int rssi;
}

class ScanFailedEvent {
  int errorCode;
}

@HostApi()
abstract class PlatformAidlabSdk {
  void scanForDevices();

  void stopDeviceScan();

  void connect(ConnectRequest request);
}

@FlutterApi()
abstract class PlatformAidlabSdkDelegate {
  void onBluetoothStarted(EmptyEvent voidEvent);

  void onDeviceScanStarted(EmptyEvent voidEvent);

  void onDeviceScanStopped(EmptyEvent voidEvent);

  void onScanFailed(ScanFailedEvent event);

  void onAidlabDetected(AidlabDetectedEvent event);
}
